using System.Security.Claims;
using e_suite.API.Common;
using e_suite.UnitTestCore;
using eSuite.API.Controllers;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Moq;

namespace eSuite.API.UnitTests.Controllers.UserManagerControllerUnitTests;

public abstract class UserManagerControllerTestBase : TestBase
{
    protected UserController _userManagerController = null!;
    protected Mock<IUserManager> _userManagerMock = null!;
    protected Mock<IRoleManager> _roleManagerMock = null!;

    protected const string AccessDeniedText = "Access denied";
    protected const string BadRequestText = "Bad request";
    protected const string NotFoundText = "Not found";
    protected const string LoginAcceptedText = "Login accepted";

    public override async Task Setup()
    {
        await base.Setup();

        _userManagerMock = new Mock<IUserManager>();
        _roleManagerMock = new Mock<IRoleManager>();

        _userManagerController = new UserController(_userManagerMock.Object, _roleManagerMock.Object);

        const long id = -1;
        const string email = "test@test.test";
        const string displayName = "Testy McTester";

        AddAuthorisedUserToController(id, email, displayName);
    }

    protected void AddAuthorisedUserToController(long id, string email, string displayName)
    {
        var user = new ClaimsPrincipal(new ClaimsIdentity(new Claim[]
        {
            new(ClaimTypes.PrimarySid, id.ToString()),
            new(ClaimTypes.Email, email),
            new(ClaimTypes.Name, displayName)
            // other required and custom claims
        }, "TestAuthentication"));

        _userManagerController.ControllerContext = new ControllerContext
        {
            HttpContext = new DefaultHttpContext { User = user }
        };
    }
}